class WeekDay 
	include Comparable
	attr_reader :num

	def initialize(num)
		raise(IndexError, "Number out if range") if num > 13 || num < 0
		@num = num
	end
	def name
		%w(Sun Mon Tue Wed Thu Fri Sat)[@num % 7]
	end

	# Support for "print" and company
	def to_s
		self.name
	end

	# Support for "p" and company
	def inspect
		self.name
	end

	# Support for ranges
	def <=>(other)
		self.num <=> other.num
	end
	def succ
		WeekDay.new(@num.succ)
	end
end

workDays = WeekDay.new(0) .. WeekDay.new(4)
p workDays.to_a     # [Sun, Mon, Tue, Wed, Thu]

(WeekDay.new(1) .. WeekDay.new(8)).each { |i| puts i.succ }
# [Tue, Wed, Thu, Fri, Sat, Sun, Mon, Tue]
